function getBooleanPreferenceValue(fieldName, prefs) {
	var tmp;

	if (prefs.getPrefType("datepicker."+fieldName) == prefs.PREF_BOOL){
		tmp = prefs.getBoolPref("datepicker."+fieldName);
	} else {
		tmp = false;
	}

	return tmp;
}

function getCharacterPreferenceValue(fieldName, prefs) {
	return getCharacterPreferenceValueWithDefault(fieldName, prefs, "Unknown");
}

function getCharacterPreferenceValueWithDefault(fieldName, prefs, defaultValue) {
	var tmp;

	if (prefs.getPrefType("datepicker."+fieldName) == prefs.PREF_STRING){
		tmp = prefs.getCharPref("datepicker."+fieldName);
	} else {
		tmp = defaultValue;
	}

	return tmp;
}

function getIntegerPreferenceValue(fieldName, prefs, defaultValue) {
	var tmp;

	if (prefs.getPrefType("datepicker."+fieldName) == prefs.PREF_INT){
		tmp = prefs.getIntPref("datepicker."+fieldName);
	} else {
		tmp = defaultValue;
	}

	return tmp;
}

function saveCharacterField(fieldName, prefs) {
	var tmp = document.getElementById(fieldName).value;
	prefs.setCharPref("datepicker."+fieldName, tmp);
}

function saveIntegerField(fieldName, prefs) {
	var tmp = document.getElementById(fieldName).value;
	prefs.setIntPref("datepicker."+fieldName, tmp);
}

function saveBooleanField(fieldName, prefs) {
	var tmp = document.getElementById(fieldName).checked;
	prefs.setBoolPref("datepicker."+fieldName, tmp);
}

function saveDropDownField(fieldName, prefs) {
	var tmp = document.getElementById(fieldName).selectedIndex;
	prefs.setIntPref("datepicker."+fieldName, tmp);
}
